// Auto-generated. Do not edit!

// (in-package etsi_its_mcm_uulm_msgs.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;
let ItsPduHeader = require('./ItsPduHeader.js');
let ManeuverCoordinationMessage = require('./ManeuverCoordinationMessage.js');

//-----------------------------------------------------------

class MCM {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.header = null;
      this.mcm = null;
    }
    else {
      if (initObj.hasOwnProperty('header')) {
        this.header = initObj.header
      }
      else {
        this.header = new ItsPduHeader();
      }
      if (initObj.hasOwnProperty('mcm')) {
        this.mcm = initObj.mcm
      }
      else {
        this.mcm = new ManeuverCoordinationMessage();
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type MCM
    // Serialize message field [header]
    bufferOffset = ItsPduHeader.serialize(obj.header, buffer, bufferOffset);
    // Serialize message field [mcm]
    bufferOffset = ManeuverCoordinationMessage.serialize(obj.mcm, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type MCM
    let len;
    let data = new MCM(null);
    // Deserialize message field [header]
    data.header = ItsPduHeader.deserialize(buffer, bufferOffset);
    // Deserialize message field [mcm]
    data.mcm = ManeuverCoordinationMessage.deserialize(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += ManeuverCoordinationMessage.getMessageSize(object.mcm);
    return length + 6;
  }

  static datatype() {
    // Returns string type for a message object
    return 'etsi_its_mcm_uulm_msgs/MCM';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return 'a12e7be7fcadb90a64224120590fde2e';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
    # python3
    #   utils/codegen/codegen-py/asn1ToRosMsg.py
    #   asn1/patched/uulm_mcm_etsi/TS103561_LUKAS_MCM.asn
    #   asn1/patched/uulm_mcm_etsi/ETSI-ITS-CDD.asn
    #   -t
    #   mcm_uulm
    #   -o
    #   etsi_its_msgs/etsi_its_mcm_uulm_msgs/msg
    # ------------------------------------------------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # MCM ::= SEQUENCE {
    # 	header  ItsPduHeader,
    # 	mcm     ManeuverCoordinationMessage
    # }
    # ------------------------------------------------------------------------------
    
    ItsPduHeader header
    
    ManeuverCoordinationMessage mcm
    
    
    ================================================================================
    MSG: etsi_its_mcm_uulm_msgs/ItsPduHeader
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
    # python3
    #   utils/codegen/codegen-py/asn1ToRosMsg.py
    #   asn1/patched/uulm_mcm_etsi/TS103561_LUKAS_MCM.asn
    #   asn1/patched/uulm_mcm_etsi/ETSI-ITS-CDD.asn
    #   -t
    #   mcm_uulm
    #   -o
    #   etsi_its_msgs/etsi_its_mcm_uulm_msgs/msg
    # ------------------------------------------------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # /**
    #  * This DF represents a common message header for application and facilities layer messages.
    #  * It is included at the beginning of an ITS message as the message header.
    #  *
    #  * It shall include the following components:
    #  *
    #  * @field protocolVersion: version of the ITS message.
    #  *
    #  * @field messageId: type of the ITS message.
    #  *
    #  * @field stationId: the identifier of the ITS-S that generated the ITS message.
    #  *
    #  * @category: Communication information
    #  * @revision:  update in V2.1.1: messageID and stationID changed to messageId and stationId; messageId is of type MessageId.
    #  */
    # ItsPduHeader ::= SEQUENCE {
    #     protocolVersion    OrdinalNumber1B,
    #     messageId          MessageId,
    #     stationId          StationId
    # }
    # ------------------------------------------------------------------------------
    
    OrdinalNumber1B protocol_version
    
    MessageId message_id
    
    StationId station_id
    
    
    ================================================================================
    MSG: etsi_its_mcm_uulm_msgs/OrdinalNumber1B
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
    # python3
    #   utils/codegen/codegen-py/asn1ToRosMsg.py
    #   asn1/patched/uulm_mcm_etsi/TS103561_LUKAS_MCM.asn
    #   asn1/patched/uulm_mcm_etsi/ETSI-ITS-CDD.asn
    #   -t
    #   mcm_uulm
    #   -o
    #   etsi_its_msgs/etsi_its_mcm_uulm_msgs/msg
    # ------------------------------------------------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # /**
    #  * The DE represents an ordinal number that indicates the position of an element in a set.
    #  *
    #  * @category: Basic information
    #  * @revision: Created in V2.1.1
    # */
    # OrdinalNumber1B ::= INTEGER(0..255)
    # ------------------------------------------------------------------------------
    
    uint8 value
    uint8 MIN = 0
    uint8 MAX = 255
    
    
    ================================================================================
    MSG: etsi_its_mcm_uulm_msgs/MessageId
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
    # python3
    #   utils/codegen/codegen-py/asn1ToRosMsg.py
    #   asn1/patched/uulm_mcm_etsi/TS103561_LUKAS_MCM.asn
    #   asn1/patched/uulm_mcm_etsi/ETSI-ITS-CDD.asn
    #   -t
    #   mcm_uulm
    #   -o
    #   etsi_its_msgs/etsi_its_mcm_uulm_msgs/msg
    # ------------------------------------------------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # /**
    #  * This DE represents the type of facility layer message.
    #  *
    #  *  The value shall be set to:
    #  *	- 1  - `denm`              - for Decentralized Environmental Notification Message (DENM) as specified in ETSI EN 302 637-3 [2],
    #  *  - 2  - `cam`               - for Cooperative Awareness Message (CAM) as specified in ETSI EN 302 637-2 [1],
    #  *  - 3  - `poim`              - for Point of Interest message as specified in ETSI TS 103 916 [9],
    #  *  - 4  - `spatem`            - for Signal Phase And Timing Extended Message (SPATEM) as specified in ETSI TS 103 301 [15],
    #  *  - 5  - `mapem`             - for MAP Extended Message (MAPEM) as specified in ETSI TS 103 301 [15],
    #  *  - 6  - `ivim`              - for in Vehicle Information Message (IVIM) as specified in ETSI TS 103 301 [15],
    #  *  - 7  - `rfu1`              - reserved for future usage,
    #  *  - 8  - `rfu2`              - reserved for future usage,
    #  *  - 9  - `srem`              - for Signal Request Extended Message as specified in ETSI TS 103 301 [15],
    #  *  - 10 - `ssem`              - for Signal request Status Extended Message as specified in ETSI TS 103 301 [15],
    #  *  - 11 - `evcsn`             - for Electrical Vehicle Charging Spot Notification message as specified in ETSI TS 101 556-1 [9],
    #  *  - 12 - `saem`              - for Services Announcement Extended Message as specified in ETSI EN 302 890-1 [17],
    #  *  - 13 - `rtcmem`            - for Radio Technical Commission for Maritime Services Extended Message (RTCMEM) as specified in ETSI TS 103 301 [15],
    #  *  - 14 - `cpm`               - reserved for Collective Perception Message (CPM),
    #  *  - 15 - `imzm`              - for Interference Management Zone Message (IMZM) as specified in ETSI TS 103 724 [13],
    #  *  - 16 - `vam`               - for Vulnerable Road User Awareness Message as specified in ETSI TS 130 300-3 [12],
    #  *  - 17 - `dsm`               - reserved for Diagnosis, logging and Status Message,
    #  *  - 18 - `pcim`              - reserved for Parking Control Infrastructure Message,
    #  *  - 19 - `pcvm`              - reserved for Parking Control Vehicle Message,
    #  *  - 20 - `mcm`               - reserved for Manoeuvre Coordination Message,
    #  *  - 21 - `pam`               - reserved for Parking Availability Message,
    #  *  - 22-255                   - reserved for future usage.
    #  *
    #  * @category: Communication information
    #  * @revision: Created in V2.1.1 from @ref ItsPduHeader. Value 3 re-assigned to poim and value 7 and 8 reserved in V2.2.1
    #  */
    # MessageId::= INTEGER {
    #     denm              (1),
    #     cam               (2),
    #     poim              (3),
    #     spatem            (4),
    #     mapem             (5),
    #     ivim              (6),
    #     rfu1              (7),
    #     rfu2              (8),
    #     srem              (9),
    #     ssem              (10),
    #     evcsn             (11),
    #     saem              (12),
    #     rtcmem            (13),
    #     cpm               (14),
    #     imzm              (15),
    #     vam               (16),
    #     dsm               (17),
    #     pcim              (18),
    #     pcvm              (19),
    #     mcm               (20),
    #     pam               (21)
    # } (0..255)
    # ------------------------------------------------------------------------------
    
    uint8 value
    uint8 MIN = 0
    uint8 MAX = 255
    uint8 DENM = 1
    uint8 CAM = 2
    uint8 POIM = 3
    uint8 SPATEM = 4
    uint8 MAPEM = 5
    uint8 IVIM = 6
    uint8 RFU1 = 7
    uint8 RFU2 = 8
    uint8 SREM = 9
    uint8 SSEM = 10
    uint8 EVCSN = 11
    uint8 SAEM = 12
    uint8 RTCMEM = 13
    uint8 CPM = 14
    uint8 IMZM = 15
    uint8 VAM = 16
    uint8 DSM = 17
    uint8 PCIM = 18
    uint8 PCVM = 19
    uint8 MCM = 20
    uint8 PAM = 21
    
    
    ================================================================================
    MSG: etsi_its_mcm_uulm_msgs/StationId
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
    # python3
    #   utils/codegen/codegen-py/asn1ToRosMsg.py
    #   asn1/patched/uulm_mcm_etsi/TS103561_LUKAS_MCM.asn
    #   asn1/patched/uulm_mcm_etsi/ETSI-ITS-CDD.asn
    #   -t
    #   mcm_uulm
    #   -o
    #   etsi_its_msgs/etsi_its_mcm_uulm_msgs/msg
    # ------------------------------------------------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # /**
    #  * This DE represents the identifier of an ITS-S.
    #  * The ITS-S ID may be a pseudonym. It may change over space and/or over time.
    #  *
    #  * @category: Basic information
    #  * @revision: Created in V2.1.1 based on @ref StationID
    #  */
    # StationId ::= INTEGER(0..4294967295)
    # ------------------------------------------------------------------------------
    
    uint32 value
    uint32 MIN = 0
    uint32 MAX = 4294967295
    
    
    ================================================================================
    MSG: etsi_its_mcm_uulm_msgs/ManeuverCoordinationMessage
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
    # python3
    #   utils/codegen/codegen-py/asn1ToRosMsg.py
    #   asn1/patched/uulm_mcm_etsi/TS103561_LUKAS_MCM.asn
    #   asn1/patched/uulm_mcm_etsi/ETSI-ITS-CDD.asn
    #   -t
    #   mcm_uulm
    #   -o
    #   etsi_its_msgs/etsi_its_mcm_uulm_msgs/msg
    # ------------------------------------------------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # ManeuverCoordinationMessage ::= SEQUENCE {
    # 	generationDeltaTime GenerationDeltaTime,
    # 	mcmParameters       McmParameters
    # }
    # ------------------------------------------------------------------------------
    
    GenerationDeltaTime generation_delta_time
    
    McmParameters mcm_parameters
    
    
    ================================================================================
    MSG: etsi_its_mcm_uulm_msgs/GenerationDeltaTime
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
    # python3
    #   utils/codegen/codegen-py/asn1ToRosMsg.py
    #   asn1/patched/uulm_mcm_etsi/TS103561_LUKAS_MCM.asn
    #   asn1/patched/uulm_mcm_etsi/ETSI-ITS-CDD.asn
    #   -t
    #   mcm_uulm
    #   -o
    #   etsi_its_msgs/etsi_its_mcm_uulm_msgs/msg
    # ------------------------------------------------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # /**
    #  * This DE represents a timestamp based on TimestampIts modulo 65 536.
    #  * This means that generationDeltaTime = TimestampIts mod 65 536.
    #  *
    #  * @category: Basic information
    #  * @revision: Created in V2.1.1 based on ETSI TS 103 900 [1]
    # */
    # GenerationDeltaTime ::= INTEGER { oneMilliSec(1) } (0..65535)
    # ------------------------------------------------------------------------------
    
    uint16 value
    uint16 MIN = 0
    uint16 MAX = 65535
    uint16 ONE_MILLI_SEC = 1
    
    
    ================================================================================
    MSG: etsi_its_mcm_uulm_msgs/McmParameters
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
    # python3
    #   utils/codegen/codegen-py/asn1ToRosMsg.py
    #   asn1/patched/uulm_mcm_etsi/TS103561_LUKAS_MCM.asn
    #   asn1/patched/uulm_mcm_etsi/ETSI-ITS-CDD.asn
    #   -t
    #   mcm_uulm
    #   -o
    #   etsi_its_msgs/etsi_its_mcm_uulm_msgs/msg
    # ------------------------------------------------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # McmParameters ::= SEQUENCE {
    # 	basicContainer      BasicContainer,
    # 	maneuverContainer   ManeuverContainer
    # }
    # ------------------------------------------------------------------------------
    
    BasicContainer basic_container
    
    ManeuverContainer maneuver_container
    
    
    ================================================================================
    MSG: etsi_its_mcm_uulm_msgs/BasicContainer
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
    # python3
    #   utils/codegen/codegen-py/asn1ToRosMsg.py
    #   asn1/patched/uulm_mcm_etsi/TS103561_LUKAS_MCM.asn
    #   asn1/patched/uulm_mcm_etsi/ETSI-ITS-CDD.asn
    #   -t
    #   mcm_uulm
    #   -o
    #   etsi_its_msgs/etsi_its_mcm_uulm_msgs/msg
    # ------------------------------------------------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # /**
    #  * This DE represents a general container for usage in various types of messages.
    #  *
    #  * It shall include the following components:
    #  *
    #  * @field stationType: the type of technical context in which the ITS-S that has generated the message is integrated in.
    #  *
    #  * @field referencePosition: the reference position of the station that has generated the message that contains the basic container.
    #  *
    #  * @category: Basic information
    #  * @revision: Created in V2.1.1
    # */
    # BasicContainer ::= SEQUENCE {
    # 	stationType          TrafficParticipantType,
    # 	referencePosition    ReferencePositionWithConfidence,
    # 	...
    # }
    # ------------------------------------------------------------------------------
    
    TrafficParticipantType station_type
    
    ReferencePositionWithConfidence reference_position
    
    
    ================================================================================
    MSG: etsi_its_mcm_uulm_msgs/TrafficParticipantType
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
    # python3
    #   utils/codegen/codegen-py/asn1ToRosMsg.py
    #   asn1/patched/uulm_mcm_etsi/TS103561_LUKAS_MCM.asn
    #   asn1/patched/uulm_mcm_etsi/ETSI-ITS-CDD.asn
    #   -t
    #   mcm_uulm
    #   -o
    #   etsi_its_msgs/etsi_its_mcm_uulm_msgs/msg
    # ------------------------------------------------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # /**
    #  * This DE represents the type of a traffic participant.
    #  *
    #  * The value shall be set to:
    #  * - 0 `unknown`          - information about traffic participant is not provided,
    #  * - 1 `pedestrian`       - human being not using a mechanical device for their trip (VRU profile 1),
    #  * - 2 `cyclist`          - non-motorized unicycles, bicycles , tricycles, quadracycles (VRU profile 2),
    #  * - 3 `moped`            - light motor vehicles with less than four wheels as defined in UNECE/TRANS/WP.29/78/Rev.4 [16] class L1, L2 (VRU Profile 3),
    #  * - 4 `motorcycles`      - motor vehicles with less than four wheels as defined in UNECE/TRANS/WP.29/78/Rev.4 [16] class L3, L4, L5, L6, L7 (VRU Profile 3),
    #  * - 5 `passengerCar`     - small passenger vehicles as defined in UNECE/TRANS/WP.29/78/Rev.4 [16] class M1,
    #  * - 6 `bus`              - large passenger vehicles as defined in UNECE/TRANS/WP.29/78/Rev.4 [16] class M2, M3,
    #  * - 7 `lightTruck`       - light Goods Vehicles as defined in UNECE/TRANS/WP.29/78/Rev.4 [16] class N1,
    #  * - 8 `heavyTruck`       - Heavy Goods Vehicles as defined in UNECE/TRANS/WP.29/78/Rev.4 [16] class N2 and N3,
    #  * - 9 `trailer`          - unpowered vehicle that is intended to be towed by a powered vehicle as defined in UNECE/TRANS/WP.29/78/Rev.4 [16] class O,
    #  * - 10 `specialVehicles` - vehicles which have special purposes other than the above (e.g. moving road works vehicle),
    #  * - 11 `tram`            - vehicle which runs on tracks along public streets,
    #  * - 12 `lightVruVehicle` - human being traveling on light vehicle, incl. possible use of roller skates or skateboards (VRU profile 2),
    #  * - 13 `animal`          - animal presenting a safety risk to other road users e.g. domesticated dog in a city or horse (VRU Profile 4),
    #  * - 14 `agricultural`    - agricultural and forestry vehicles as defined in UNECE/TRANS/WP.29/78/Rev.4 [16] class T,
    #  * - 15 `roadSideUnit`    - infrastructure typically positioned outside of the drivable roadway (e.g. on a gantry, on a pole,
    #                             on a stationary road works trailer); the infrastructure is static during the entire operation period of the ITS-S (e.g. no stop and go activity),
    #  * - 16-255               - are reserved for future usage.
    #  *
    #  * @category: Communication information.
    #  * @revision: Created in V2.1.1 based on StationType
    #  */
    # TrafficParticipantType ::= INTEGER {
    #     unknown         (0),
    #     pedestrian      (1),
    #     cyclist         (2),
    #     moped           (3),
    #     motorcycle      (4),
    #     passengerCar    (5),
    #     bus             (6),
    #     lightTruck      (7),
    #     heavyTruck      (8),
    #     trailer         (9),
    #     specialVehicle  (10),
    #     tram            (11),
    #     lightVruVehicle (12),
    #     animal          (13),
    #     agricultural    (14),
    #     roadSideUnit    (15)
    # } (0..255)
    # ------------------------------------------------------------------------------
    
    uint8 value
    uint8 MIN = 0
    uint8 MAX = 255
    uint8 UNKNOWN = 0
    uint8 PEDESTRIAN = 1
    uint8 CYCLIST = 2
    uint8 MOPED = 3
    uint8 MOTORCYCLE = 4
    uint8 PASSENGER_CAR = 5
    uint8 BUS = 6
    uint8 LIGHT_TRUCK = 7
    uint8 HEAVY_TRUCK = 8
    uint8 TRAILER = 9
    uint8 SPECIAL_VEHICLE = 10
    uint8 TRAM = 11
    uint8 LIGHT_VRU_VEHICLE = 12
    uint8 ANIMAL = 13
    uint8 AGRICULTURAL = 14
    uint8 ROAD_SIDE_UNIT = 15
    
    
    ================================================================================
    MSG: etsi_its_mcm_uulm_msgs/ReferencePositionWithConfidence
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
    # python3
    #   utils/codegen/codegen-py/asn1ToRosMsg.py
    #   asn1/patched/uulm_mcm_etsi/TS103561_LUKAS_MCM.asn
    #   asn1/patched/uulm_mcm_etsi/ETSI-ITS-CDD.asn
    #   -t
    #   mcm_uulm
    #   -o
    #   etsi_its_msgs/etsi_its_mcm_uulm_msgs/msg
    # ------------------------------------------------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # /**
    #  * A position within a geographic coordinate system together with a confidence ellipse.
    #  *
    #  * It shall include the following components:
    #  *
    #  * @field latitude: the latitude of the geographical point.
    #  *
    #  * @field longitude: the longitude of the geographical point.
    #  *
    #  * @field positionConfidenceEllipse: the confidence ellipse associated to the geographical position.
    #  *
    #  * @field altitude: the altitude and an altitude accuracy of the geographical point.
    #  *
    #  * @category: GeoReference information
    #  * @revision: created in V2.1.1 based on @ref ReferencePosition but using @ref PositionConfidenceEllipse.
    #  */
    # ReferencePositionWithConfidence ::= SEQUENCE {
    #     latitude                     Latitude,
    #     longitude                    Longitude,
    #     positionConfidenceEllipse    PositionConfidenceEllipse,
    #     altitude                     Altitude
    # }
    # ------------------------------------------------------------------------------
    
    Latitude latitude
    
    Longitude longitude
    
    PositionConfidenceEllipse position_confidence_ellipse
    
    Altitude altitude
    
    
    ================================================================================
    MSG: etsi_its_mcm_uulm_msgs/Latitude
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
    # python3
    #   utils/codegen/codegen-py/asn1ToRosMsg.py
    #   asn1/patched/uulm_mcm_etsi/TS103561_LUKAS_MCM.asn
    #   asn1/patched/uulm_mcm_etsi/ETSI-ITS-CDD.asn
    #   -t
    #   mcm_uulm
    #   -o
    #   etsi_its_msgs/etsi_its_mcm_uulm_msgs/msg
    # ------------------------------------------------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # /**
    #  * This DE represents the absolute geographical latitude in a WGS84 coordinate system, providing a range of 90 degrees in north or
    #  * in south hemisphere.
    #  * The specific WGS84 coordinate system is specified by the corresponding standards applying this DE.
    #  *
    #  * The value shall be set to:
    #  * - `n` (`n >= -900 000 000` and `n < 0`) x 10^-7 degree, i.e. negative values for latitudes south of the Equator,
    #  * - `0` is used for the latitude of the equator,
    #  * - `n` (`n > 0` and `n < 900 000 001`) x 10^-7 degree, i.e. positive values for latitudes north of the Equator,
    #  * - `900 000 001` when the information is unavailable.
    #  *
    #  * @unit: 10^-7 degree
    #  * @category: GeoReference information
    #  * @revision: Editorial update in V2.1.1
    #  */
    # Latitude ::= INTEGER {
    #     unavailable(900000001)
    # } (-900000000..900000001)
    # ------------------------------------------------------------------------------
    
    int32 value
    int32 MIN = -900000000
    int32 MAX = 900000001
    int32 UNAVAILABLE = 900000001
    
    
    ================================================================================
    MSG: etsi_its_mcm_uulm_msgs/Longitude
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
    # python3
    #   utils/codegen/codegen-py/asn1ToRosMsg.py
    #   asn1/patched/uulm_mcm_etsi/TS103561_LUKAS_MCM.asn
    #   asn1/patched/uulm_mcm_etsi/ETSI-ITS-CDD.asn
    #   -t
    #   mcm_uulm
    #   -o
    #   etsi_its_msgs/etsi_its_mcm_uulm_msgs/msg
    # ------------------------------------------------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # /**
    #  * This DE represents the absolute geographical longitude in a WGS84 coordinate system, providing a range of 180 degrees
    #  * to the east or to the west of the prime meridian.
    #  * The specific WGS84 coordinate system is specified by the corresponding standards applying this DE.
    #  *
    #  * The value shall be set to:
    #  * - `n` (`n > -1 800 000 000` and `n < 0`) x 10^-7 degree, i.e. negative values for longitudes to the west,
    #  * - `0` to indicate the prime meridian,
    #  * - `n` (`n > 0` and `n < 1 800 000 001`) x 10^-7 degree, i.e. positive values for longitudes to the east,
    #  * - `1 800 000 001` when the information is unavailable.
    #  *
    #  * The value -1 800 000 000 shall not be used.
    #  *
    #  * @unit: 10^-7 degree
    #  * @category: GeoReference information
    #  * @revision: Description revised in V2.1.1
    #  */
    # Longitude ::= INTEGER {
    #     valueNotUsed (-1800000000),
    #     unavailable  (1800000001)
    # } (-1800000000..1800000001)
    # ------------------------------------------------------------------------------
    
    int32 value
    int32 MIN = -1800000000
    int32 MAX = 1800000001
    int32 VALUE_NOT_USED = -1800000000
    int32 UNAVAILABLE = 1800000001
    
    
    ================================================================================
    MSG: etsi_its_mcm_uulm_msgs/PositionConfidenceEllipse
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
    # python3
    #   utils/codegen/codegen-py/asn1ToRosMsg.py
    #   asn1/patched/uulm_mcm_etsi/TS103561_LUKAS_MCM.asn
    #   asn1/patched/uulm_mcm_etsi/ETSI-ITS-CDD.asn
    #   -t
    #   mcm_uulm
    #   -o
    #   etsi_its_msgs/etsi_its_mcm_uulm_msgs/msg
    # ------------------------------------------------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # /**
    #  * This DF indicates the horizontal position confidence ellipse which represents the estimated accuracy with a
    #  * confidence level of 95 %. The centre of the ellipse shape corresponds to the reference
    #  * position point for which the position accuracy is evaluated.
    #  *
    #  * It shall include the following components:
    #  *
    #  * @field semiMajorAxisLength: half of length of the major axis, i.e. distance between the centre point
    #  * and major axis point of the position accuracy ellipse.
    #  *
    #  * @field semiMinorAxisLength: half of length of the minor axis, i.e. distance between the centre point
    #  * and minor axis point of the position accuracy ellipse.
    #  *
    #  * @field semiMajorAxisOrientation: orientation direction of the ellipse major axis of the position accuracy
    #  * ellipse with regards to the WGS84 north.
    #  * The specific WGS84 coordinate system is specified by the corresponding standards applying this DE.
    #  *
    #  * @category GeoReference information
    #  * @revision: created in V2.1.1 based on @ref PosConfidenceEllipse
    #  */
    # PositionConfidenceEllipse ::= SEQUENCE {
    #     semiMajorAxisLength         SemiAxisLength,
    #     semiMinorAxisLength         SemiAxisLength,
    #     semiMajorAxisOrientation    Wgs84AngleValue
    # }
    # ------------------------------------------------------------------------------
    
    SemiAxisLength semi_major_axis_length
    
    SemiAxisLength semi_minor_axis_length
    
    Wgs84AngleValue semi_major_axis_orientation
    
    
    ================================================================================
    MSG: etsi_its_mcm_uulm_msgs/SemiAxisLength
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
    # python3
    #   utils/codegen/codegen-py/asn1ToRosMsg.py
    #   asn1/patched/uulm_mcm_etsi/TS103561_LUKAS_MCM.asn
    #   asn1/patched/uulm_mcm_etsi/ETSI-ITS-CDD.asn
    #   -t
    #   mcm_uulm
    #   -o
    #   etsi_its_msgs/etsi_its_mcm_uulm_msgs/msg
    # ------------------------------------------------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # /**
    #  * This DE indicates the horizontal position confidence value which represents the estimated absolute position accuracy, in one of the axis direction as defined in a shape of ellipse with a
    #  * confidence level of 95 %.
    #  *
    #  * The value shall be set to:
    #  * - `n` (`n > 0` and `n < 4 094`) if the accuracy is equal to or less than n * 0,01 metre,
    #  * - `4 094` if the accuracy is out of range, i.e. greater than 4,093 m,
    #  * - `4 095` if the accuracy information is unavailable.
    #  *
    #  * The value 0 shall not be used.
    #  *
    #  * @note: The fact that a position coordinate value is received with confidence value set to `unavailable(4095)`.
    #  * can be caused by several reasons, such as:
    #  * - the sensor cannot deliver the accuracy at the defined confidence level because it is a low-end sensor,
    #  * - the sensor cannot calculate the accuracy due to lack of variables, or
    #  * - there has been a vehicle bus (e.g. CAN bus) error.
    #  * In all 3 cases above, the position coordinate value may be valid and used by the application.
    #  * If a position coordinate value is received and its confidence value is set to `outOfRange(4094)`, it means that
    #  * the position coordinate value is not valid and therefore cannot be trusted. Such value is not useful
    #  * for the application.
    # 
    #  * @unit 0,01 metre
    #  * @category: GeoReference Information
    #  * @revision: Description revised in V2.1.1
    #  */
    # SemiAxisLength ::= INTEGER{
    #     doNotUse    (0),
    #     outOfRange  (4094),
    #     unavailable (4095)
    # } (0..4095)
    # ------------------------------------------------------------------------------
    
    uint16 value
    uint16 MIN = 0
    uint16 MAX = 4095
    uint16 DO_NOT_USE = 0
    uint16 OUT_OF_RANGE = 4094
    uint16 UNAVAILABLE = 4095
    
    
    ================================================================================
    MSG: etsi_its_mcm_uulm_msgs/Wgs84AngleValue
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
    # python3
    #   utils/codegen/codegen-py/asn1ToRosMsg.py
    #   asn1/patched/uulm_mcm_etsi/TS103561_LUKAS_MCM.asn
    #   asn1/patched/uulm_mcm_etsi/ETSI-ITS-CDD.asn
    #   -t
    #   mcm_uulm
    #   -o
    #   etsi_its_msgs/etsi_its_mcm_uulm_msgs/msg
    # ------------------------------------------------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # /**
    #  * This DE represents an angle value in degrees described in the WGS84 reference system with respect to the WGS84 north.
    #  * The specific WGS84 coordinate system is specified by the corresponding standards applying this DE.
    #  * When the information is not available, the DE shall be set to 3 601. The value 3600 shall not be used.
    #  *
    #  * @unit 0,1 degrees
    #  * @category: GeoReference Information
    #  * @revision: Created in V2.1.1
    # */
    # Wgs84AngleValue ::= INTEGER {
    #     wgs84North  (0),
    #     wgs84East   (900),
    #     wgs84South  (1800),
    #     wgs84West   (2700),
    #     doNotUse    (3600),
    #     unavailable (3601)
    # } (0..3601)
    # ------------------------------------------------------------------------------
    
    uint16 value
    uint16 MIN = 0
    uint16 MAX = 3601
    uint16 WGS84_NORTH = 0
    uint16 WGS84_EAST = 900
    uint16 WGS84_SOUTH = 1800
    uint16 WGS84_WEST = 2700
    uint16 DO_NOT_USE = 3600
    uint16 UNAVAILABLE = 3601
    
    
    ================================================================================
    MSG: etsi_its_mcm_uulm_msgs/Altitude
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
    # python3
    #   utils/codegen/codegen-py/asn1ToRosMsg.py
    #   asn1/patched/uulm_mcm_etsi/TS103561_LUKAS_MCM.asn
    #   asn1/patched/uulm_mcm_etsi/ETSI-ITS-CDD.asn
    #   -t
    #   mcm_uulm
    #   -o
    #   etsi_its_msgs/etsi_its_mcm_uulm_msgs/msg
    # ------------------------------------------------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # /**
    #  * This DF provides the altitude and confidence level of an altitude information in a WGS84 coordinate system.
    #  * The specific WGS84 coordinate system is specified by the corresponding standards applying this DE.
    #  *
    #  * It shall include the following components:
    #  *
    #  * @field altitudeValue: altitude of a geographical point.
    #  *
    #  * @field altitudeConfidence: confidence level of the altitudeValue.
    #  *
    #  * @note: this DF is kept for backwards compatibility reasons only. It is recommended to use the @ref AltitudeWithConfidence instead.
    #  * @category: GeoReference information
    #  * @revision: Description revised in V2.1.1
    #  */
    # Altitude ::= SEQUENCE {
    #     altitudeValue         AltitudeValue,
    #     altitudeConfidence    AltitudeConfidence
    # }
    # ------------------------------------------------------------------------------
    
    AltitudeValue altitude_value
    
    AltitudeConfidence altitude_confidence
    
    
    ================================================================================
    MSG: etsi_its_mcm_uulm_msgs/AltitudeValue
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
    # python3
    #   utils/codegen/codegen-py/asn1ToRosMsg.py
    #   asn1/patched/uulm_mcm_etsi/TS103561_LUKAS_MCM.asn
    #   asn1/patched/uulm_mcm_etsi/ETSI-ITS-CDD.asn
    #   -t
    #   mcm_uulm
    #   -o
    #   etsi_its_msgs/etsi_its_mcm_uulm_msgs/msg
    # ------------------------------------------------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # /**
    #  * This DE represents the altitude value in a WGS84 coordinate system.
    #  * The specific WGS84 coordinate system is specified by the corresponding standards applying this DE.
    #  *
    #  * The value shall be set to:
    #  * - `-100 000` if the altitude is equal to or less than -1 000 m,
    #  * - `n` (`n > -100 000` and `n < 800 000`) if the altitude is equal to or less than n  x 0,01 metre and greater than (n-1) x 0,01 metre,
    #  * - `800 000` if the altitude  greater than 7 999,99 m,
    #  * - `800 001` if the information is not available.
    #  *
    #  * @note: the range of this DE does not use the full binary encoding range, but all reasonable values are covered. In order to cover all possible altitude ranges a larger encoding would be necessary.
    #  * @unit: 0,01 metre
    #  * @category: GeoReference information
    #  * @revision: Description revised in V2.1.1 (definition of 800 000 has slightly changed)
    #  */
    # AltitudeValue ::= INTEGER {
    #     negativeOutOfRange (-100000),
    #     postiveOutOfRange  (800000),
    #     unavailable        (800001)
    # } (-100000..800001)
    # ------------------------------------------------------------------------------
    
    int32 value
    int32 MIN = -100000
    int32 MAX = 800001
    int32 NEGATIVE_OUT_OF_RANGE = -100000
    int32 POSTIVE_OUT_OF_RANGE = 800000
    int32 UNAVAILABLE = 800001
    
    
    ================================================================================
    MSG: etsi_its_mcm_uulm_msgs/AltitudeConfidence
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
    # python3
    #   utils/codegen/codegen-py/asn1ToRosMsg.py
    #   asn1/patched/uulm_mcm_etsi/TS103561_LUKAS_MCM.asn
    #   asn1/patched/uulm_mcm_etsi/ETSI-ITS-CDD.asn
    #   -t
    #   mcm_uulm
    #   -o
    #   etsi_its_msgs/etsi_its_mcm_uulm_msgs/msg
    # ------------------------------------------------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # /**
    #  * This DE indicates the altitude confidence value which represents the estimated absolute accuracy of an altitude value of a geographical point with a default confidence level of 95 %.
    #  * If required, the confidence level can be defined by the corresponding standards applying this DE.
    #  *
    #  * The value shall be set to:
    #  *   - 0  - `alt-000-01`   - if the confidence value is equal to or less than 0,01 metre,
    #  *   - 1  - `alt-000-02`   - if the confidence value is equal to or less than 0,02 metre and greater than 0,01 metre,
    #  *   - 2  - `alt-000-05`   - if the confidence value is equal to or less than 0,05 metre and greater than 0,02 metre,
    #  *   - 3  - `alt-000-10`   - if the confidence value is equal to or less than 0,1 metre and greater than 0,05 metre,
    #  *   - 4  - `alt-000-20`   - if the confidence value is equal to or less than 0,2 metre and greater than 0,1 metre,
    #  *   - 5  - `alt-000-50`   - if the confidence value is equal to or less than 0,5 metre and greater than 0,2 metre,
    #  *   - 6  - `alt-001-00`   - if the confidence value is equal to or less than 1 metre and greater than 0,5 metre,
    #  *   - 7  - `alt-002-00`   - if the confidence value is equal to or less than 2 metres and greater than 1 metre,
    #  *   - 8  - `alt-005-00`   - if the confidence value is equal to or less than 5 metres and greater than 2 metres,
    #  *   - 9  - `alt-010-00`   - if the confidence value is equal to or less than 10 metres and greater than 5 metres,
    #  *   - 10 - `alt-020-00`   - if the confidence value is equal to or less than 20 metres and greater than 10 metres,
    #  *   - 11 - `alt-050-00`   - if the confidence value is equal to or less than 50 metres and greater than 20 metres,
    #  *   - 12 - `alt-100-00`   - if the confidence value is equal to or less than 100 metres and greater than 50 metres,
    #  *   - 13 - `alt-200-00`   - if the confidence value is equal to or less than 200 metres and greater than 100 metres,
    #  *   - 14 - `outOfRange`   - if the confidence value is out of range, i.e. greater than 200 metres,
    #  *   - 15 - `unavailable`  - if the confidence value is unavailable.
    #  *
    #  * @note: The fact that an altitude value is received with confidence value set to `unavailable(15)` can be caused
    #  * by several reasons, such as:
    #  * - the sensor cannot deliver the accuracy at the defined confidence level because it is a low-end sensor,
    #  * - the sensor cannot calculate the accuracy due to lack of variables, or
    #  * - there has been a vehicle bus (e.g. CAN bus) error.
    #  * In all 3 cases above, the altitude value may be valid and used by the application.
    #  *
    #  * @note: If an altitude value is received and its confidence value is set to `outOfRange(14)`, it means that the
    #  * altitude value is not valid and therefore cannot be trusted. Such value is not useful for the application.
    #  *
    #  * @category: GeoReference information
    #  * @revision: Description revised in V2.1.1
    #  */
    # AltitudeConfidence ::= ENUMERATED {
    #     alt-000-01  (0),
    #     alt-000-02  (1),
    #     alt-000-05  (2),
    #     alt-000-10  (3),
    #     alt-000-20  (4),
    #     alt-000-50  (5),
    #     alt-001-00  (6),
    #     alt-002-00  (7),
    #     alt-005-00  (8),
    #     alt-010-00  (9),
    #     alt-020-00  (10),
    #     alt-050-00  (11),
    #     alt-100-00  (12),
    #     alt-200-00  (13),
    #     outOfRange  (14),
    #     unavailable (15)
    # }
    # ------------------------------------------------------------------------------
    
    uint8 value
    uint8 ALT_000_01 = 0
    uint8 ALT_000_02 = 1
    uint8 ALT_000_05 = 2
    uint8 ALT_000_10 = 3
    uint8 ALT_000_20 = 4
    uint8 ALT_000_50 = 5
    uint8 ALT_001_00 = 6
    uint8 ALT_002_00 = 7
    uint8 ALT_005_00 = 8
    uint8 ALT_010_00 = 9
    uint8 ALT_020_00 = 10
    uint8 ALT_050_00 = 11
    uint8 ALT_100_00 = 12
    uint8 ALT_200_00 = 13
    uint8 OUT_OF_RANGE = 14
    uint8 UNAVAILABLE = 15
    
    
    ================================================================================
    MSG: etsi_its_mcm_uulm_msgs/ManeuverContainer
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
    # python3
    #   utils/codegen/codegen-py/asn1ToRosMsg.py
    #   asn1/patched/uulm_mcm_etsi/TS103561_LUKAS_MCM.asn
    #   asn1/patched/uulm_mcm_etsi/ETSI-ITS-CDD.asn
    #   -t
    #   mcm_uulm
    #   -o
    #   etsi_its_msgs/etsi_its_mcm_uulm_msgs/msg
    # ------------------------------------------------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # ManeuverContainer ::= CHOICE {
    # 	roadUserContainer           RoadUserContainer,
    # 	suggestedManeuverContainer  SuggestedManeuverContainer
    # }
    # ------------------------------------------------------------------------------
    
    uint8 choice
    
    RoadUserContainer road_user_container
    uint8 CHOICE_ROAD_USER_CONTAINER = 0
    
    SuggestedManeuverContainer suggested_maneuver_container
    uint8 CHOICE_SUGGESTED_MANEUVER_CONTAINER = 1
    
    
    ================================================================================
    MSG: etsi_its_mcm_uulm_msgs/RoadUserContainer
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
    # python3
    #   utils/codegen/codegen-py/asn1ToRosMsg.py
    #   asn1/patched/uulm_mcm_etsi/TS103561_LUKAS_MCM.asn
    #   asn1/patched/uulm_mcm_etsi/ETSI-ITS-CDD.asn
    #   -t
    #   mcm_uulm
    #   -o
    #   etsi_its_msgs/etsi_its_mcm_uulm_msgs/msg
    # ------------------------------------------------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # RoadUserContainer ::= SEQUENCE {
    # 	roadUserState       RoadUserState,
    # 	plannedTrajectory   PlannedTrajectory   OPTIONAL,
    # 	desiredRoute        DesiredRoute        OPTIONAL,
    # 	adviceResponse      AdviceResponse      OPTIONAL
    # }
    # ------------------------------------------------------------------------------
    
    RoadUserState road_user_state
    
    PlannedTrajectory planned_trajectory
    bool planned_trajectory_is_present
    
    DesiredRoute desired_route
    bool desired_route_is_present
    
    AdviceResponse advice_response
    bool advice_response_is_present
    
    
    ================================================================================
    MSG: etsi_its_mcm_uulm_msgs/RoadUserState
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
    # python3
    #   utils/codegen/codegen-py/asn1ToRosMsg.py
    #   asn1/patched/uulm_mcm_etsi/TS103561_LUKAS_MCM.asn
    #   asn1/patched/uulm_mcm_etsi/ETSI-ITS-CDD.asn
    #   -t
    #   mcm_uulm
    #   -o
    #   etsi_its_msgs/etsi_its_mcm_uulm_msgs/msg
    # ------------------------------------------------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # RoadUserState ::= SEQUENCE {
    # 	roadUserType    RoadUserType,
    # 	speed           SpeedValue,
    # 	heading         HeadingValue,
    # 	length          RoadUserLength,
    # 	width           RoadUserWidth
    # }
    # ------------------------------------------------------------------------------
    
    RoadUserType road_user_type
    
    SpeedValue speed
    
    HeadingValue heading
    
    RoadUserLength length
    
    RoadUserWidth width
    
    
    ================================================================================
    MSG: etsi_its_mcm_uulm_msgs/RoadUserType
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
    # python3
    #   utils/codegen/codegen-py/asn1ToRosMsg.py
    #   asn1/patched/uulm_mcm_etsi/TS103561_LUKAS_MCM.asn
    #   asn1/patched/uulm_mcm_etsi/ETSI-ITS-CDD.asn
    #   -t
    #   mcm_uulm
    #   -o
    #   etsi_its_msgs/etsi_its_mcm_uulm_msgs/msg
    # ------------------------------------------------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # RoadUserType ::= ENUMERATED {
    # 	connectedVehicle            (0),
    # 	connectedAutomatedVehicle   (1),
    # 	connectedCyclist            (2),
    # 	connectedPedestrian         (3),
    # 	connectedRoadSweeper        (4),
    # 	connectedCollectionVehicle  (5),
    # 	...
    # }
    # ------------------------------------------------------------------------------
    
    uint8 value
    uint8 CONNECTED_VEHICLE = 0
    uint8 CONNECTED_AUTOMATED_VEHICLE = 1
    uint8 CONNECTED_CYCLIST = 2
    uint8 CONNECTED_PEDESTRIAN = 3
    uint8 CONNECTED_ROAD_SWEEPER = 4
    uint8 CONNECTED_COLLECTION_VEHICLE = 5
    
    
    ================================================================================
    MSG: etsi_its_mcm_uulm_msgs/SpeedValue
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
    # python3
    #   utils/codegen/codegen-py/asn1ToRosMsg.py
    #   asn1/patched/uulm_mcm_etsi/TS103561_LUKAS_MCM.asn
    #   asn1/patched/uulm_mcm_etsi/ETSI-ITS-CDD.asn
    #   -t
    #   mcm_uulm
    #   -o
    #   etsi_its_msgs/etsi_its_mcm_uulm_msgs/msg
    # ------------------------------------------------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # /**
    #  * This DE represents a speed value, i.e. the magnitude of the velocity-vector.
    #  *
    #  * The value shall be set to:
    #  * - `0` in a standstill situation.
    #  * - `n` (`n > 0` and `n < 16 382`) if the applicable value is equal to or less than n x 0,01 m/s, and greater than (n-1) x 0,01 m/s,
    #  * - `16 382` for speed values greater than 163,81 m/s,
    #  * - `16 383` if the speed accuracy information is not available.
    #  *
    #  * @note: the definition of standstill is out of scope of the present document.
    #  *
    #  * @unit: 0,01 m/s
    #  * @category: Kinematic information
    #  * @revision: Description revised in V2.1.1 (the meaning of 16382 has changed slightly)
    # */
    # SpeedValue ::= INTEGER {
    #     standstill  (0),
    #     outOfRange  (16382),
    #     unavailable (16383)
    # } (0..16383)
    # ------------------------------------------------------------------------------
    
    uint16 value
    uint16 MIN = 0
    uint16 MAX = 16383
    uint16 STANDSTILL = 0
    uint16 OUT_OF_RANGE = 16382
    uint16 UNAVAILABLE = 16383
    
    
    ================================================================================
    MSG: etsi_its_mcm_uulm_msgs/HeadingValue
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
    # python3
    #   utils/codegen/codegen-py/asn1ToRosMsg.py
    #   asn1/patched/uulm_mcm_etsi/TS103561_LUKAS_MCM.asn
    #   asn1/patched/uulm_mcm_etsi/ETSI-ITS-CDD.asn
    #   -t
    #   mcm_uulm
    #   -o
    #   etsi_its_msgs/etsi_its_mcm_uulm_msgs/msg
    # ------------------------------------------------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # /**
    #  * This DE represents the orientation of the horizontal velocity vector with regards to the WGS84 north.
    #  * When the information is not available, the DE shall be set to 3 601. The value 3600 shall not be used.
    #  *
    #  * @note: this DE is kept for backwards compatibility reasons only. It is recommended to use the @ref Wgs84AngleValue instead.
    #  *
    #  * Unit: 0,1 degree
    #  * Categories: GeoReference information
    #  * @revision: Description revised in V2.1.1 (usage of value 3600 specified)
    # */
    # HeadingValue ::= INTEGER {
    #     wgs84North  (0),
    #     wgs84East   (900),
    #     wgs84South  (1800),
    #     wgs84West   (2700),
    #     doNotUse    (3600),
    #     unavailable (3601)
    # } (0..3601)
    # ------------------------------------------------------------------------------
    
    uint16 value
    uint16 MIN = 0
    uint16 MAX = 3601
    uint16 WGS84_NORTH = 0
    uint16 WGS84_EAST = 900
    uint16 WGS84_SOUTH = 1800
    uint16 WGS84_WEST = 2700
    uint16 DO_NOT_USE = 3600
    uint16 UNAVAILABLE = 3601
    
    
    ================================================================================
    MSG: etsi_its_mcm_uulm_msgs/RoadUserLength
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
    # python3
    #   utils/codegen/codegen-py/asn1ToRosMsg.py
    #   asn1/patched/uulm_mcm_etsi/TS103561_LUKAS_MCM.asn
    #   asn1/patched/uulm_mcm_etsi/ETSI-ITS-CDD.asn
    #   -t
    #   mcm_uulm
    #   -o
    #   etsi_its_msgs/etsi_its_mcm_uulm_msgs/msg
    # ------------------------------------------------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # RoadUserLength ::= INTEGER {
    # 	tenCentimeters   (1),
    # 	outOfRange      (61),
    # 	unavailable     (62)
    # } (1..62)
    # ------------------------------------------------------------------------------
    
    uint8 value
    uint8 MIN = 1
    uint8 MAX = 62
    uint8 TEN_CENTIMETERS = 1
    uint8 OUT_OF_RANGE = 61
    uint8 UNAVAILABLE = 62
    
    
    ================================================================================
    MSG: etsi_its_mcm_uulm_msgs/RoadUserWidth
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
    # python3
    #   utils/codegen/codegen-py/asn1ToRosMsg.py
    #   asn1/patched/uulm_mcm_etsi/TS103561_LUKAS_MCM.asn
    #   asn1/patched/uulm_mcm_etsi/ETSI-ITS-CDD.asn
    #   -t
    #   mcm_uulm
    #   -o
    #   etsi_its_msgs/etsi_its_mcm_uulm_msgs/msg
    # ------------------------------------------------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # RoadUserWidth ::= INTEGER {
    # 	tenCentimeters   (1),
    # 	outOfRange      (61),
    # 	unavailable     (62)
    # } (1..62)
    # ------------------------------------------------------------------------------
    
    uint8 value
    uint8 MIN = 1
    uint8 MAX = 62
    uint8 TEN_CENTIMETERS = 1
    uint8 OUT_OF_RANGE = 61
    uint8 UNAVAILABLE = 62
    
    
    ================================================================================
    MSG: etsi_its_mcm_uulm_msgs/PlannedTrajectory
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
    # python3
    #   utils/codegen/codegen-py/asn1ToRosMsg.py
    #   asn1/patched/uulm_mcm_etsi/TS103561_LUKAS_MCM.asn
    #   asn1/patched/uulm_mcm_etsi/ETSI-ITS-CDD.asn
    #   -t
    #   mcm_uulm
    #   -o
    #   etsi_its_msgs/etsi_its_mcm_uulm_msgs/msg
    # ------------------------------------------------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # PlannedTrajectory ::= SEQUENCE {
    # 	startDeltaTime              TrajectoryStartDeltaTime,
    # 	deltaTime                   TrajectoryPointDeltaTime,
    # 	trajectoryPointContainer    TrajectoryPointContainer
    # }
    # ------------------------------------------------------------------------------
    
    TrajectoryStartDeltaTime start_delta_time
    
    TrajectoryPointDeltaTime delta_time
    
    TrajectoryPointContainer trajectory_point_container
    
    
    ================================================================================
    MSG: etsi_its_mcm_uulm_msgs/TrajectoryStartDeltaTime
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
    # python3
    #   utils/codegen/codegen-py/asn1ToRosMsg.py
    #   asn1/patched/uulm_mcm_etsi/TS103561_LUKAS_MCM.asn
    #   asn1/patched/uulm_mcm_etsi/ETSI-ITS-CDD.asn
    #   -t
    #   mcm_uulm
    #   -o
    #   etsi_its_msgs/etsi_its_mcm_uulm_msgs/msg
    # ------------------------------------------------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # TrajectoryStartDeltaTime ::= INTEGER { oneMilliSec(1) } (0..65535)
    # ------------------------------------------------------------------------------
    
    uint16 value
    uint16 MIN = 0
    uint16 MAX = 65535
    uint16 ONE_MILLI_SEC = 1
    
    
    ================================================================================
    MSG: etsi_its_mcm_uulm_msgs/TrajectoryPointDeltaTime
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
    # python3
    #   utils/codegen/codegen-py/asn1ToRosMsg.py
    #   asn1/patched/uulm_mcm_etsi/TS103561_LUKAS_MCM.asn
    #   asn1/patched/uulm_mcm_etsi/ETSI-ITS-CDD.asn
    #   -t
    #   mcm_uulm
    #   -o
    #   etsi_its_msgs/etsi_its_mcm_uulm_msgs/msg
    # ------------------------------------------------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # TrajectoryPointDeltaTime ::= INTEGER { oneMilliSec(1) } (1..255)
    # ------------------------------------------------------------------------------
    
    uint8 value
    uint8 MIN = 1
    uint8 MAX = 255
    uint8 ONE_MILLI_SEC = 1
    
    
    ================================================================================
    MSG: etsi_its_mcm_uulm_msgs/TrajectoryPointContainer
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
    # python3
    #   utils/codegen/codegen-py/asn1ToRosMsg.py
    #   asn1/patched/uulm_mcm_etsi/TS103561_LUKAS_MCM.asn
    #   asn1/patched/uulm_mcm_etsi/ETSI-ITS-CDD.asn
    #   -t
    #   mcm_uulm
    #   -o
    #   etsi_its_msgs/etsi_its_mcm_uulm_msgs/msg
    # ------------------------------------------------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # TrajectoryPointContainer ::= SEQUENCE SIZE(1..128, ...) OF TrajectoryPoint
    # ------------------------------------------------------------------------------
    
    TrajectoryPoint[] array
    uint8 MIN_SIZE = 1
    uint8 MAX_SIZE = 128
    
    
    ================================================================================
    MSG: etsi_its_mcm_uulm_msgs/TrajectoryPoint
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
    # python3
    #   utils/codegen/codegen-py/asn1ToRosMsg.py
    #   asn1/patched/uulm_mcm_etsi/TS103561_LUKAS_MCM.asn
    #   asn1/patched/uulm_mcm_etsi/ETSI-ITS-CDD.asn
    #   -t
    #   mcm_uulm
    #   -o
    #   etsi_its_msgs/etsi_its_mcm_uulm_msgs/msg
    # ------------------------------------------------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # TrajectoryPoint ::= SEQUENCE {
    # 	waypoint    Waypoint,
    # 	speed       SpeedValue,
    # 	heading     HeadingValue
    # }
    # ------------------------------------------------------------------------------
    
    Waypoint waypoint
    
    SpeedValue speed
    
    HeadingValue heading
    
    
    ================================================================================
    MSG: etsi_its_mcm_uulm_msgs/Waypoint
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
    # python3
    #   utils/codegen/codegen-py/asn1ToRosMsg.py
    #   asn1/patched/uulm_mcm_etsi/TS103561_LUKAS_MCM.asn
    #   asn1/patched/uulm_mcm_etsi/ETSI-ITS-CDD.asn
    #   -t
    #   mcm_uulm
    #   -o
    #   etsi_its_msgs/etsi_its_mcm_uulm_msgs/msg
    # ------------------------------------------------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # Waypoint ::= SEQUENCE {
    # 	xDistance CartesianCoordinateLarge,
    # 	yDistance CartesianCoordinateLarge
    # }
    # ------------------------------------------------------------------------------
    
    CartesianCoordinateLarge x_distance
    
    CartesianCoordinateLarge y_distance
    
    
    ================================================================================
    MSG: etsi_its_mcm_uulm_msgs/CartesianCoordinateLarge
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
    # python3
    #   utils/codegen/codegen-py/asn1ToRosMsg.py
    #   asn1/patched/uulm_mcm_etsi/TS103561_LUKAS_MCM.asn
    #   asn1/patched/uulm_mcm_etsi/ETSI-ITS-CDD.asn
    #   -t
    #   mcm_uulm
    #   -o
    #   etsi_its_msgs/etsi_its_mcm_uulm_msgs/msg
    # ------------------------------------------------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # /**
    #  * This DF represents the value of a cartesian coordinate with a range of -1 310,72 metres to +1 310,70 metres.
    #  *
    #  * The value shall be set to:
    #  * - `-131072` if the longitudinal offset is out of range, i.e. less than or equal to -1 310,72 metres,
    #  * - `n` (`n > 131 072` and `n < 131 071`) if the longitudinal offset information is equal to or less than n x 0,01 metre and more than (n-1) x 0,01 metre,
    #  * - `131 071` if the longitudinal offset is out of range, i.e. greater than + 1 310,70 metres.
    #  *
    #  * @unit 0,01 m
    #  * @category: Basic information
    #  * @revision: Created in V2.1.1
    # */
    # CartesianCoordinateLarge::= INTEGER{
    #     negativeOutOfRange (-131072),
    #     positiveOutOfRange (131071)
    # } (-131072..131071)
    # ------------------------------------------------------------------------------
    
    int32 value
    int32 MIN = -131072
    int32 MAX = 131071
    int32 NEGATIVE_OUT_OF_RANGE = -131072
    int32 POSITIVE_OUT_OF_RANGE = 131071
    
    
    ================================================================================
    MSG: etsi_its_mcm_uulm_msgs/DesiredRoute
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
    # python3
    #   utils/codegen/codegen-py/asn1ToRosMsg.py
    #   asn1/patched/uulm_mcm_etsi/TS103561_LUKAS_MCM.asn
    #   asn1/patched/uulm_mcm_etsi/ETSI-ITS-CDD.asn
    #   -t
    #   mcm_uulm
    #   -o
    #   etsi_its_msgs/etsi_its_mcm_uulm_msgs/msg
    # ------------------------------------------------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # DesiredRoute ::= SEQUENCE SIZE(1..128, ...) OF Waypoint
    # ------------------------------------------------------------------------------
    
    Waypoint[] array
    uint8 MIN_SIZE = 1
    uint8 MAX_SIZE = 128
    
    
    ================================================================================
    MSG: etsi_its_mcm_uulm_msgs/AdviceResponse
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
    # python3
    #   utils/codegen/codegen-py/asn1ToRosMsg.py
    #   asn1/patched/uulm_mcm_etsi/TS103561_LUKAS_MCM.asn
    #   asn1/patched/uulm_mcm_etsi/ETSI-ITS-CDD.asn
    #   -t
    #   mcm_uulm
    #   -o
    #   etsi_its_msgs/etsi_its_mcm_uulm_msgs/msg
    # ------------------------------------------------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # AdviceResponse ::= SEQUENCE {
    # 	maneuverID      ManeuverID,
    # 	adviceUpdateID  AdviceUpdateID,
    # 	adviceFollowed  ManeuverResponse
    # }
    # ------------------------------------------------------------------------------
    
    ManeuverID maneuver_id
    
    AdviceUpdateID advice_update_id
    
    ManeuverResponse advice_followed
    
    
    ================================================================================
    MSG: etsi_its_mcm_uulm_msgs/ManeuverID
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
    # python3
    #   utils/codegen/codegen-py/asn1ToRosMsg.py
    #   asn1/patched/uulm_mcm_etsi/TS103561_LUKAS_MCM.asn
    #   asn1/patched/uulm_mcm_etsi/ETSI-ITS-CDD.asn
    #   -t
    #   mcm_uulm
    #   -o
    #   etsi_its_msgs/etsi_its_mcm_uulm_msgs/msg
    # ------------------------------------------------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # ManeuverID ::= INTEGER (0..65535)
    # ------------------------------------------------------------------------------
    
    uint16 value
    uint16 MIN = 0
    uint16 MAX = 65535
    
    
    ================================================================================
    MSG: etsi_its_mcm_uulm_msgs/AdviceUpdateID
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
    # python3
    #   utils/codegen/codegen-py/asn1ToRosMsg.py
    #   asn1/patched/uulm_mcm_etsi/TS103561_LUKAS_MCM.asn
    #   asn1/patched/uulm_mcm_etsi/ETSI-ITS-CDD.asn
    #   -t
    #   mcm_uulm
    #   -o
    #   etsi_its_msgs/etsi_its_mcm_uulm_msgs/msg
    # ------------------------------------------------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # AdviceUpdateID ::= INTEGER (0..65535)
    # ------------------------------------------------------------------------------
    
    uint16 value
    uint16 MIN = 0
    uint16 MAX = 65535
    
    
    ================================================================================
    MSG: etsi_its_mcm_uulm_msgs/ManeuverResponse
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
    # python3
    #   utils/codegen/codegen-py/asn1ToRosMsg.py
    #   asn1/patched/uulm_mcm_etsi/TS103561_LUKAS_MCM.asn
    #   asn1/patched/uulm_mcm_etsi/ETSI-ITS-CDD.asn
    #   -t
    #   mcm_uulm
    #   -o
    #   etsi_its_msgs/etsi_its_mcm_uulm_msgs/msg
    # ------------------------------------------------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # ManeuverResponse ::= ENUMERATED {accept(0), reject(1), pending(2)}
    # ------------------------------------------------------------------------------
    
    uint8 value
    uint8 ACCEPT = 0
    uint8 REJECT = 1
    uint8 PENDING = 2
    
    
    ================================================================================
    MSG: etsi_its_mcm_uulm_msgs/SuggestedManeuverContainer
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
    # python3
    #   utils/codegen/codegen-py/asn1ToRosMsg.py
    #   asn1/patched/uulm_mcm_etsi/TS103561_LUKAS_MCM.asn
    #   asn1/patched/uulm_mcm_etsi/ETSI-ITS-CDD.asn
    #   -t
    #   mcm_uulm
    #   -o
    #   etsi_its_msgs/etsi_its_mcm_uulm_msgs/msg
    # ------------------------------------------------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # SuggestedManeuverContainer ::= SEQUENCE {
    # 	targetStationID     StationId,
    # 	suggestedManeuver   SuggestedManeuver OPTIONAL
    # }
    # ------------------------------------------------------------------------------
    
    StationId target_station_id
    
    SuggestedManeuver suggested_maneuver
    bool suggested_maneuver_is_present
    
    
    ================================================================================
    MSG: etsi_its_mcm_uulm_msgs/SuggestedManeuver
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
    # python3
    #   utils/codegen/codegen-py/asn1ToRosMsg.py
    #   asn1/patched/uulm_mcm_etsi/TS103561_LUKAS_MCM.asn
    #   asn1/patched/uulm_mcm_etsi/ETSI-ITS-CDD.asn
    #   -t
    #   mcm_uulm
    #   -o
    #   etsi_its_msgs/etsi_its_mcm_uulm_msgs/msg
    # ------------------------------------------------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # SuggestedManeuver ::= SEQUENCE {
    # 	maneuverID                          ManeuverID,
    # 	adviceUpdateID                      AdviceUpdateID,
    # 	participatingRoadUserIDContainer    ParticipatingRoadUserIDContainer,
    # 	confirmationRequiredFlag            ConfirmationRequiredFlag,
    # 	maneuverParameters                  ManeuverParameters
    # }
    # ------------------------------------------------------------------------------
    
    ManeuverID maneuver_id
    
    AdviceUpdateID advice_update_id
    
    ParticipatingRoadUserIDContainer participating_road_user_id_container
    
    ConfirmationRequiredFlag confirmation_required_flag
    
    ManeuverParameters maneuver_parameters
    
    
    ================================================================================
    MSG: etsi_its_mcm_uulm_msgs/ParticipatingRoadUserIDContainer
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
    # python3
    #   utils/codegen/codegen-py/asn1ToRosMsg.py
    #   asn1/patched/uulm_mcm_etsi/TS103561_LUKAS_MCM.asn
    #   asn1/patched/uulm_mcm_etsi/ETSI-ITS-CDD.asn
    #   -t
    #   mcm_uulm
    #   -o
    #   etsi_its_msgs/etsi_its_mcm_uulm_msgs/msg
    # ------------------------------------------------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # ParticipatingRoadUserIDContainer ::= SEQUENCE SIZE(1..128, ...) OF StationId
    # ------------------------------------------------------------------------------
    
    StationId[] array
    uint8 MIN_SIZE = 1
    uint8 MAX_SIZE = 128
    
    
    ================================================================================
    MSG: etsi_its_mcm_uulm_msgs/ConfirmationRequiredFlag
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
    # python3
    #   utils/codegen/codegen-py/asn1ToRosMsg.py
    #   asn1/patched/uulm_mcm_etsi/TS103561_LUKAS_MCM.asn
    #   asn1/patched/uulm_mcm_etsi/ETSI-ITS-CDD.asn
    #   -t
    #   mcm_uulm
    #   -o
    #   etsi_its_msgs/etsi_its_mcm_uulm_msgs/msg
    # ------------------------------------------------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # ConfirmationRequiredFlag ::= BOOLEAN
    # ------------------------------------------------------------------------------
    
    bool value
    
    
    ================================================================================
    MSG: etsi_its_mcm_uulm_msgs/ManeuverParameters
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
    # python3
    #   utils/codegen/codegen-py/asn1ToRosMsg.py
    #   asn1/patched/uulm_mcm_etsi/TS103561_LUKAS_MCM.asn
    #   asn1/patched/uulm_mcm_etsi/ETSI-ITS-CDD.asn
    #   -t
    #   mcm_uulm
    #   -o
    #   etsi_its_msgs/etsi_its_mcm_uulm_msgs/msg
    # ------------------------------------------------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # ManeuverParameters ::= CHOICE {
    # 	maneuverConstraints ManeuverConstraints,
    # 	terminationStatus   TerminationStatus
    # }
    # ------------------------------------------------------------------------------
    
    uint8 choice
    
    ManeuverConstraints maneuver_constraints
    uint8 CHOICE_MANEUVER_CONSTRAINTS = 0
    
    TerminationStatus termination_status
    uint8 CHOICE_TERMINATION_STATUS = 1
    
    
    ================================================================================
    MSG: etsi_its_mcm_uulm_msgs/ManeuverConstraints
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
    # python3
    #   utils/codegen/codegen-py/asn1ToRosMsg.py
    #   asn1/patched/uulm_mcm_etsi/TS103561_LUKAS_MCM.asn
    #   asn1/patched/uulm_mcm_etsi/ETSI-ITS-CDD.asn
    #   -t
    #   mcm_uulm
    #   -o
    #   etsi_its_msgs/etsi_its_mcm_uulm_msgs/msg
    # ------------------------------------------------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # ManeuverConstraints ::= SEQUENCE {
    # 	maneuverType                            ManeuverType OPTIONAL,
    # 	longitudinalManeuverWaypointContainer   LongitudinalManeuverWaypointContainer,
    # 	maneuverCorridor                        Polygon OPTIONAL
    # }
    # ------------------------------------------------------------------------------
    
    ManeuverType maneuver_type
    bool maneuver_type_is_present
    
    LongitudinalManeuverWaypointContainer longitudinal_maneuver_waypoint_container
    
    Polygon maneuver_corridor
    bool maneuver_corridor_is_present
    
    
    ================================================================================
    MSG: etsi_its_mcm_uulm_msgs/ManeuverType
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
    # python3
    #   utils/codegen/codegen-py/asn1ToRosMsg.py
    #   asn1/patched/uulm_mcm_etsi/TS103561_LUKAS_MCM.asn
    #   asn1/patched/uulm_mcm_etsi/ETSI-ITS-CDD.asn
    #   -t
    #   mcm_uulm
    #   -o
    #   etsi_its_msgs/etsi_its_mcm_uulm_msgs/msg
    # ------------------------------------------------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # ManeuverType ::= ENUMERATED {
    # 	freeTravel           (0),
    # 	followRoadUser       (1),
    # 	crossIntersection    (2),
    # 	yieldAtIntersection  (3),
    # 	overtake             (4),
    # 	pullOver             (5),
    # 	yieldAtObstacle      (6),
    # 	maneuverTypeUnknown  (15)
    # }
    # ------------------------------------------------------------------------------
    
    uint8 value
    uint8 FREE_TRAVEL = 0
    uint8 FOLLOW_ROAD_USER = 1
    uint8 CROSS_INTERSECTION = 2
    uint8 YIELD_AT_INTERSECTION = 3
    uint8 OVERTAKE = 4
    uint8 PULL_OVER = 5
    uint8 YIELD_AT_OBSTACLE = 6
    uint8 MANEUVER_TYPE_UNKNOWN = 15
    
    
    ================================================================================
    MSG: etsi_its_mcm_uulm_msgs/LongitudinalManeuverWaypointContainer
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
    # python3
    #   utils/codegen/codegen-py/asn1ToRosMsg.py
    #   asn1/patched/uulm_mcm_etsi/TS103561_LUKAS_MCM.asn
    #   asn1/patched/uulm_mcm_etsi/ETSI-ITS-CDD.asn
    #   -t
    #   mcm_uulm
    #   -o
    #   etsi_its_msgs/etsi_its_mcm_uulm_msgs/msg
    # ------------------------------------------------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # LongitudinalManeuverWaypointContainer ::= SEQUENCE SIZE(1..128, ...) OF LongitudinalWaypoint
    # ------------------------------------------------------------------------------
    
    LongitudinalWaypoint[] array
    uint8 MIN_SIZE = 1
    uint8 MAX_SIZE = 128
    
    
    ================================================================================
    MSG: etsi_its_mcm_uulm_msgs/LongitudinalWaypoint
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
    # python3
    #   utils/codegen/codegen-py/asn1ToRosMsg.py
    #   asn1/patched/uulm_mcm_etsi/TS103561_LUKAS_MCM.asn
    #   asn1/patched/uulm_mcm_etsi/ETSI-ITS-CDD.asn
    #   -t
    #   mcm_uulm
    #   -o
    #   etsi_its_msgs/etsi_its_mcm_uulm_msgs/msg
    # ------------------------------------------------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # LongitudinalWaypoint ::= SEQUENCE {
    # 	waypoint                    Waypoint,
    # 	minArrivalTime              WaypointDeltaTime,
    # 	maxArrivalTime              WaypointDeltaTime,
    # 	minVelocity                 SpeedValue          OPTIONAL,
    # 	maxVelocity                 SpeedValue          OPTIONAL,
    # 	minDurationOfStop           WaypointDeltaTime           OPTIONAL,
    # 	precedingRoadUser           ParticipatingRoadUserIndex  OPTIONAL,
    # 	followingRoadUser           ParticipatingRoadUserIndex  OPTIONAL,
    # 	yieldToRoadUserContainer    YieldToRoadUserContainer    OPTIONAL
    # }
    # ------------------------------------------------------------------------------
    
    Waypoint waypoint
    
    WaypointDeltaTime min_arrival_time
    
    WaypointDeltaTime max_arrival_time
    
    SpeedValue min_velocity
    bool min_velocity_is_present
    
    SpeedValue max_velocity
    bool max_velocity_is_present
    
    WaypointDeltaTime min_duration_of_stop
    bool min_duration_of_stop_is_present
    
    ParticipatingRoadUserIndex preceding_road_user
    bool preceding_road_user_is_present
    
    ParticipatingRoadUserIndex following_road_user
    bool following_road_user_is_present
    
    YieldToRoadUserContainer yield_to_road_user_container
    bool yield_to_road_user_container_is_present
    
    
    ================================================================================
    MSG: etsi_its_mcm_uulm_msgs/WaypointDeltaTime
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
    # python3
    #   utils/codegen/codegen-py/asn1ToRosMsg.py
    #   asn1/patched/uulm_mcm_etsi/TS103561_LUKAS_MCM.asn
    #   asn1/patched/uulm_mcm_etsi/ETSI-ITS-CDD.asn
    #   -t
    #   mcm_uulm
    #   -o
    #   etsi_its_msgs/etsi_its_mcm_uulm_msgs/msg
    # ------------------------------------------------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # WaypointDeltaTime ::= INTEGER { oneMilliSec(1) } (0..65535)
    # ------------------------------------------------------------------------------
    
    uint16 value
    uint16 MIN = 0
    uint16 MAX = 65535
    uint16 ONE_MILLI_SEC = 1
    
    
    ================================================================================
    MSG: etsi_its_mcm_uulm_msgs/ParticipatingRoadUserIndex
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
    # python3
    #   utils/codegen/codegen-py/asn1ToRosMsg.py
    #   asn1/patched/uulm_mcm_etsi/TS103561_LUKAS_MCM.asn
    #   asn1/patched/uulm_mcm_etsi/ETSI-ITS-CDD.asn
    #   -t
    #   mcm_uulm
    #   -o
    #   etsi_its_msgs/etsi_its_mcm_uulm_msgs/msg
    # ------------------------------------------------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # ParticipatingRoadUserIndex ::= INTEGER(0..127)
    # ------------------------------------------------------------------------------
    
    uint8 value
    uint8 MIN = 0
    uint8 MAX = 127
    
    
    ================================================================================
    MSG: etsi_its_mcm_uulm_msgs/YieldToRoadUserContainer
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
    # python3
    #   utils/codegen/codegen-py/asn1ToRosMsg.py
    #   asn1/patched/uulm_mcm_etsi/TS103561_LUKAS_MCM.asn
    #   asn1/patched/uulm_mcm_etsi/ETSI-ITS-CDD.asn
    #   -t
    #   mcm_uulm
    #   -o
    #   etsi_its_msgs/etsi_its_mcm_uulm_msgs/msg
    # ------------------------------------------------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # YieldToRoadUserContainer ::= SEQUENCE SIZE(1..16, ...) OF ParticipatingRoadUserIndex
    # ------------------------------------------------------------------------------
    
    ParticipatingRoadUserIndex[] array
    uint8 MIN_SIZE = 1
    uint8 MAX_SIZE = 16
    
    
    ================================================================================
    MSG: etsi_its_mcm_uulm_msgs/Polygon
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
    # python3
    #   utils/codegen/codegen-py/asn1ToRosMsg.py
    #   asn1/patched/uulm_mcm_etsi/TS103561_LUKAS_MCM.asn
    #   asn1/patched/uulm_mcm_etsi/ETSI-ITS-CDD.asn
    #   -t
    #   mcm_uulm
    #   -o
    #   etsi_its_msgs/etsi_its_mcm_uulm_msgs/msg
    # ------------------------------------------------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # Polygon ::= SEQUENCE SIZE(1..128, ...) OF Waypoint
    # ------------------------------------------------------------------------------
    
    Waypoint[] array
    uint8 MIN_SIZE = 1
    uint8 MAX_SIZE = 128
    
    
    ================================================================================
    MSG: etsi_its_mcm_uulm_msgs/TerminationStatus
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
    # python3
    #   utils/codegen/codegen-py/asn1ToRosMsg.py
    #   asn1/patched/uulm_mcm_etsi/TS103561_LUKAS_MCM.asn
    #   asn1/patched/uulm_mcm_etsi/ETSI-ITS-CDD.asn
    #   -t
    #   mcm_uulm
    #   -o
    #   etsi_its_msgs/etsi_its_mcm_uulm_msgs/msg
    # ------------------------------------------------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # TerminationStatus ::= ENUMERATED {
    # 	regularEnd                           (0),
    # 	abortByReject                        (1),
    # 	abortByTimeout                       (2),
    # 	abortByConstraintViolation           (3),
    # 	abortByEmergencyVehicleAppearance    (4),
    # 	reasonUnknown                       (15)
    # }
    # ------------------------------------------------------------------------------
    
    uint8 value
    uint8 REGULAR_END = 0
    uint8 ABORT_BY_REJECT = 1
    uint8 ABORT_BY_TIMEOUT = 2
    uint8 ABORT_BY_CONSTRAINT_VIOLATION = 3
    uint8 ABORT_BY_EMERGENCY_VEHICLE_APPEARANCE = 4
    uint8 REASON_UNKNOWN = 15
    
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new MCM(null);
    if (msg.header !== undefined) {
      resolved.header = ItsPduHeader.Resolve(msg.header)
    }
    else {
      resolved.header = new ItsPduHeader()
    }

    if (msg.mcm !== undefined) {
      resolved.mcm = ManeuverCoordinationMessage.Resolve(msg.mcm)
    }
    else {
      resolved.mcm = new ManeuverCoordinationMessage()
    }

    return resolved;
    }
};

module.exports = MCM;
